zoukankan      html  css  js  c++  java
  • Evanyou Blog 彩带

      题目传送

      

    Parity game
    Time Limit: 1000MS   Memory Limit: 65536K
    Total Submissions: 10870   Accepted: 4182

    Description

    Now and then you play the following game with your friend. Your friend writes down a sequence consisting of zeroes and ones. You choose a continuous subsequence (for example the subsequence from the third to the fifth digit inclusively) and ask him, whether this subsequence contains even or odd number of ones. Your friend answers your question and you can ask him about another subsequence and so on. Your task is to guess the entire sequence of numbers. 

    You suspect some of your friend's answers may not be correct and you want to convict him of falsehood. Thus you have decided to write a program to help you in this matter. The program will receive a series of your questions together with the answers you have received from your friend. The aim of this program is to find the first answer which is provably wrong, i.e. that there exists a sequence satisfying answers to all the previous questions, but no such sequence satisfies this answer.

    Input

    The first line of input contains one number, which is the length of the sequence of zeroes and ones. This length is less or equal to 1000000000. In the second line, there is one positive integer which is the number of questions asked and answers to them. The number of questions and answers is less or equal to 5000. The remaining lines specify questions and answers. Each line contains one question and the answer to this question: two integers (the position of the first and last digit in the chosen subsequence) and one word which is either `even' or `odd' (the answer, i.e. the parity of the number of ones in the chosen subsequence, where `even' means an even number of ones and `odd' means an odd number).

    Output

    There is only one line in output containing one integer X. Number X says that there exists a sequence of zeroes and ones satisfying first X parity conditions, but there exists none satisfying X+1 conditions. If there exists a sequence of zeroes and ones satisfying all the given conditions, then number X should be the number of all the questions asked.

    Sample Input

    10
    5
    1 2 even
    3 4 odd
    5 6 even
    1 6 even
    7 10 odd

    Sample Output

    3


      分析:这道题可以用带权并查集和扩展域并查集两种方法做,这里两种方法都讲一下吧。

      首先讲带权并查集的思路。因为题目要求的是奇偶性,可知,一个01数列中从第l个元素到第r个元素之间有奇数个1,如果令sum[]为前缀和,则等价于sum[l-1]^sum[r]=1;偶数个1的情况就是sum[l-1]^sum[r]=0;这个应该不难理解。当然这个题目中我们不需要求出sum[]具体是多少,只需要知道它们之间的关系就行了。

      那么我们就可以设置并查集了,设置一个d[]数组,表示x与fa[x]之间的关系(也就是sum[x]^sum[fa[x]])。每次询问时,先令x=l-1,y=r,找到fa[x]与fa[y],再判断一下,如果x,y在同一并查集里,那么就直接看d[x]^d[y]是否等于所询问的关系,如果不满足,直接输出答案然后退出;否则,说明目前还不知道x,y之间的关系,那就将x,y合并到同一个并查集。在操作过程中,维护d[]数组即可。

      不过由于数据范围,所以需要离散化。

      Code:

     

    #include<cstdio>
    #include<cstring>
    #include<cstdlib>
    #include<cmath>
    #include<iostream>
    #include<iomanip>
    #include<algorithm>
    #define Fi(i,a,b) for(int i=a;i<=b;i++)
    using namespace std;
    const int N=2e4+7;
    int n,m,a[N],d[N],fa[N],ans,cnt;
    struct Node{int l,r,v;}p[N];
    void ready()
    {
      cin>>n>>m;char str[5];
      Fi(i,1,m){scanf("%d%d%s",&p[i].l,&p[i].r,str);
        p[i].v=(str[0]=='e'?0:1);
      //这里p[i]表示区间奇偶性是否相同
      //如果为1则相同,否则不相同
    a[
    ++cnt]=p[i].l-1;a[++cnt]=p[i].r;} sort(a+1,a+1+cnt);n=unique(a+1,a+cnt+1)-a-1; } inline int find(int x) { if(fa[x]==x)return x; int father=find(fa[x]); d[x]^=d[fa[x]]; return fa[x]=father; } int main() { ready(); Fi(i,1,n)fa[i]=i; Fi(i,1,m){ int x=lower_bound(a+1,a+n+1,p[i].l-1)-a; int y=lower_bound(a+1,a+n+1,p[i].r)-a; int fx=find(x),fy=find(y); if(fx==fy){ if(d[x]^d[y]!=p[i].v){cout<<i-1;return 0;}} else{ fa[fy]=fx;d[fy]=d[x]^d[y]^p[i].v;}} cout<<m;return 0; }

     

     

      再来讲讲扩展域并查集的思路。这种方法我个人觉得会比较好理解。基本思路也是和上面一样用前缀和之间的关系来判断。把每个变量x变成两个x_odd和x_even,也就是奇偶两种情况。对于每一个询问,用0代表偶数,1代表奇数,那么对于每个询问只有以下情况:

      1,询问为0:判断x_odd与y_even是否在同一集合中(或者判断x_even和y_odd也一样,都是等价的,原因后面会说),如果在同一集合,则矛盾,直接输出答案;否则,合并x_odd与y_odd,x_even与y_even,表示sum[x]与sum[y]同奇偶。

      2,询问为1:判断x_odd与y_odd是否在统一集合中(当然判断x_even与y_even也一样),如果在统一集合,则矛盾,直接输出答案;否则,合并x_odd与y_even,x_even与y_odd,表示sum[x]与sum[y]异奇偶。

      可知,因为合并的时候是将两种情况一起合并的,所以两种询问是等价的。

      当然也需要离散化。

      Code:

     

    #include<cstdio>
    #include<cstring>
    #include<cstdlib>
    #include<cmath>
    #include<iostream>
    #include<iomanip>
    #include<algorithm>
    #define Fi(i,a,b) for(int i=a;i<=b;i++)
    using namespace std;
    const int N=4e4+7;
    int n,m,a[N],d[N],fa[N],ans,cnt;
    struct Node{int l,r,v;}p[N];
    void ready()
    {
      cin>>n>>m;char str[5];
      Fi(i,1,m){scanf("%d%d%s",&p[i].l,&p[i].r,str);
        p[i].v=(str[0]=='e'?0:1);
        a[++cnt]=p[i].l-1;a[++cnt]=p[i].r;}
      sort(a+1,a+1+cnt);n=unique(a+1,a+cnt+1)-a-1;
    }
    inline int find(int x)
    {return fa[x]==x?x:fa[x]=find(fa[x]);}
    int main()
    {
      ready();
      Fi(i,1,2*n)fa[i]=i;
      Fi(i,1,m){
        int x=lower_bound(a+1,a+n+1,p[i].l-1)-a;
        int y=lower_bound(a+1,a+n+1,p[i].r)-a;
        int xo=x,xe=x+n;int yo=y,ye=y+n;
        if(p[i].v==0){
          if(find(xo)==find(ye)){
        cout<<i-1;return 0;}
          fa[find(ye)]=find(xe);
          fa[find(yo)]=find(xo);}
        else {
          if(find(xo)==find(yo)){
        cout<<i-1;return 0;}
          fa[find(yo)]=find(xe);
          fa[find(ye)]=find(xo);}
      }cout<<m;return 0;
    }

     

      不过有一点令蒟蒻疑惑的是,理论上第二种方法复杂度会比第一种稍高,因为询问与操作更繁琐,但实际测出的结果第一种63ms,第二种32ms,希望大佬指教。

  • 相关阅读:
    zookeeper 介绍
    多线程、并发及线程的基础问题
    RabbitMQ
    关于JAVA IO流的学习
    SQL 的基本常识
    What is Bt?
    Python turtle库的学习笔记
    字符串简单模式匹配算法与IndexOf方法比较
    谈如何选书
    使用JavaScriptSerializer进行序列化日期类型应该注意的问题
  • 原文地址:https://www.cnblogs.com/cytus/p/8999662.html
Copyright © 2011-2022 走看看